﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Input;

namespace Lepton_Practical_MVVM_5 {
    public class MyViewModel : INotifyPropertyChanged{

        private bool _IsTextBox1Focus;
        /// <summary>
        /// TextBox1 Focus
        /// </summary>
        public virtual bool IsTextBox1Focus {
            get {
                return _IsTextBox1Focus;
            }
            set {
                _IsTextBox1Focus = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("IsTextBox1Focus"));
            }
        }


        private bool _IsTextBox2Focus;
        /// <summary>
        /// TextBox2 Focus
        /// </summary>
        public virtual bool IsTextBox2Focus {
            get {
                return _IsTextBox2Focus;
            }
            set {
                _IsTextBox2Focus = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("IsTextBox2Focus"));
            }
        }

        private bool _IsTextBox3Focus;
        /// <summary>
        /// TextBox3 Focus
        /// </summary>
        public virtual bool IsTextBox3Focus {
            get {
                return _IsTextBox3Focus;
            }
            set {
                _IsTextBox3Focus = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("IsTextBox3Focus"));
            }
        }


        private MyCommand _SetTextBox2Focus;
        public ICommand SetTextBox2Focus {
            get {
                if (_SetTextBox2Focus == null)
                    _SetTextBox2Focus = new MyCommand(x => {
                        IsTextBox2Focus = true;
                    });
                return _SetTextBox2Focus;
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        internal class MyCommand : ICommand {

            private Action<object> action;

            internal MyCommand(Action<object> action) {
                this.action = action;
            }

            #region ICommand Members

            public bool CanExecute(object parameter) {
                return true;
            }

            public event EventHandler CanExecuteChanged;

            public void Execute(object parameter) {
                action(parameter);
            }

            #endregion
        }
    }
}
